Unit Unit4;

Interface

Uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WinInet, StdCtrls, ComCtrls;

Type
  TForm4 = Class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Procedure Button1Click(Sender: TObject);
  Private
    { Dclarations prives }
  Public
    { Dclarations publiques }
  End;

Var
  Form4: TForm4;

Implementation

{$R *.dfm}

Procedure TForm4.Button1Click(Sender: TObject);
Const
  BufferSize = 1024;
Var
  hSession, hURL: HInternet;
  Buffer:         Array [1 .. BufferSize] Of Byte;
  BufferLen:      DWord;
  FS:             TFileStream;
  sFileName:      String;
Begin
  With TSaveDialog.Create(Self) Do
    Try
      Options := [ofOverwritePrompt, ofHideReadOnly, ofPathMustExist, ofEnableSizing];
      If Execute Then
        sFileName := FileName
      Else
        Exit;
    Finally
      Free;
    End;

  hSession := InternetOpen(PChar(ExtractFileName(Application.ExeName)), INTERNET_OPEN_TYPE_PRECONFIG, '', '', 0);
  If FileExists(sFileName) Then
    DeleteFile(sFileName);
  FS := TFileStream.Create(sFileName, fmCreate);
  Try
    hURL := InternetOpenURL(hSession, PChar(Edit1.Text), NIL, 0, INTERNET_FLAG_RELOAD, 0);
    Try
      Repeat
        InternetReadFile(hURL, @Buffer, BufferSize, BufferLen);
        FS.WriteBuffer(Buffer, BufferLen);
      Until BufferLen = 0;
    Finally
      InternetCloseHandle(hURL)
    End
  Finally
    InternetCloseHandle(hSession);
    FS.Free;
  End;

  MessageDlg('Tlchargement termin.', mtInformation, [mbOK], 0);
End;

End.
